diff -ur bogofilter-0.91.4/src/bogoconfig.c bogofilter-0.91.4.new/src/bogoconfig.c
--- bogofilter-0.91.4/src/bogoconfig.c	2004-05-18 08:22:51.000000000 +0800
+++ bogofilter-0.91.4.new/src/bogoconfig.c	2004-07-02 00:09:29.638832547 +0800
@@ -103,6 +103,7 @@
     { "classify-stdin",			N, 0, 'b' },
     { "bogofilter_dir",			R, 0, 'd' },
     { "ham",				N, 0, 'e' },
+    { "grace-mode",				N, 0, 'g' },
     { "help",				N, 0, 'h' },
     { "db_cachesize",			N, 0, 'k' },
     { "use-syslog",			N, 0, 'l' },
@@ -282,6 +283,7 @@
     "  -n, --register-ham        - register message(s) as non-spam.\n",
     "  -S, --unregister-spam     - unregister message(s) from spam list.\n",
     "  -N, --unregister-nonspam  - unregister message(s) from non-spam list.\n",
+    "  -g, --grace-mode          - register messages(s) as spam when not spam, or as ham when not ham.\n",
     "general options:\n",
     "  -c, --config-file=file    - read specified config file.\n",
     "  -C, --no-config-file      - don't read standard config files.\n",
@@ -485,6 +487,10 @@
 	nonspam_exits_zero = true;
 	break;
 
+    case 'g':
+	grace_mode = true;
+	break;
+
     case 'h':
 	help();
 	exit(EX_OK);
diff -ur bogofilter-0.91.4/src/bogofilter.c bogofilter-0.91.4.new/src/bogofilter.c
--- bogofilter-0.91.4/src/bogofilter.c	2004-06-05 07:07:20.000000000 +0800
+++ bogofilter-0.91.4.new/src/bogofilter.c	2004-07-02 00:47:08.458299536 +0800
@@ -102,6 +102,17 @@
         
 	if (register_opt && DEBUG_REGISTER(1))
 	    fprintf(dbgout, "Message #%ld\n", (long) msgcount);
+
+    if (grace_mode) {
+        spamicity = msg_compute_spamicity(w, NULL);
+        status = msg_status();
+        if (run_type & REG_GOOD && status != RC_HAM) {
+            run_type = run_type & (~ REG_GOOD);
+        } else if (run_type & REG_SPAM && status != RC_SPAM) {
+            run_type = run_type & (~ REG_SPAM);
+        }
+    }
+
 	if (register_bef)
 	    register_words(run_type, w, 1);
 	if (register_aft)
diff -ur bogofilter-0.91.4/src/globals.c bogofilter-0.91.4.new/src/globals.c
--- bogofilter-0.91.4/src/globals.c	2004-05-09 22:42:04.000000000 +0800
+++ bogofilter-0.91.4.new/src/globals.c	2004-07-01 23:37:31.064464170 +0800
@@ -23,6 +23,7 @@
 bool	nonspam_exits_zero;		/* '-e' */
 FILE	*fpin = NULL;			/* '-I' */
 bool	fisher;				/* '-f' */
+bool	grace_mode;				/* '-g' */
 bool	logflag;			/* '-l' */
 bool	mbox_mode;			/* '-M' */
 bool	replace_nonascii_characters;	/* '-n' */
diff -ur bogofilter-0.91.4/src/globals.h bogofilter-0.91.4.new/src/globals.h
--- bogofilter-0.91.4/src/globals.h	2004-05-09 22:42:04.000000000 +0800
+++ bogofilter-0.91.4.new/src/globals.h	2004-07-01 23:32:59.108930914 +0800
@@ -18,6 +18,7 @@
 extern	bool	suppress_config_file;	/* '-C' */
 extern	bool	nonspam_exits_zero;	/* '-e' */
 extern	bool	fisher;			/* '-f' */
+extern	bool	grace_mode;		/* '-g' */
 extern	FILE	*fpin;			/* '-I' */
 extern	bool	logflag;		/* '-l' */
 extern	bool	mbox_mode;		/* '-M' */
